Bug 1666033 (change_libcrypt.so.2) - Fully remove deprecated and unsafe functions from libcrypt
Summary: Fully remove deprecated and unsafe functions from libcrypt
Keywords:
Status: CLOSED EOL
Alias: change_libcrypt.so.2
Product: Fedora
Classification: Fedora
Component: Changes Tracking
Version: 30
Hardware: All
OS: Linux
unspecified
unspecified
Target Milestone: ---
Assignee: Björn 'besser82' Esser
QA Contact:
URL: https://fedoraproject.org/wiki/Change...
Whiteboard:
Depends On:
Blocks: change_libcrypt.so.1_posix_enosys
TreeView+ depends on / blocked
 
Reported: 2019-01-14 17:42 UTC by Ben Cotton
Modified: 2020-05-26 14:43 UTC (History)
2 users (show)

Fixed In Version: libxcrypt-4.4.2-5.fc30
Doc Type: Removed functionality
Doc Text:
The version of the libxcrypt package included with Fedora 30 now ships the libcrypt.so.2 library and does not provide the legacy API functions that have been provided by glibc's libcrypt.so.1. The removed functions by name are encrypt, encrypt_r, setkey, setkey_r, and fcrypt. If you are using a third-party application that links against those functions, or that is linked against glibc's libcrypt, you may need to install the libxcrypt-compat package manually. All existing binary executables linked against glibc's libcrypt should work unmodified with the libcrypt.so.1 library supplied by the libxcrypt-compat package.
Clone Of:
Environment:
Last Closed: 2020-05-26 14:43:37 UTC
Type: ---
besser82: fedora_requires_release_note+


Attachments (Terms of Use)

Description Ben Cotton 2019-01-14 17:42:49 UTC
This is a tracking bug for Change: Fully remove deprecated and unsafe functions from libcrypt
For more details, see: https://fedoraproject.org/wiki/Changes/FullyRemoveDeprecatedAndUnsafeFunctionsFromLibcrypt

This change is about removing binary support for deprecated and unsafe functions and bumping libcrypt.so to libcrypt.so.2.

Comment 1 Michael Schwendt 2019-01-14 20:01:07 UTC
claws-mail doesn't use libxcrypt. My patch to make it use libnettle has been merged.

Comment 2 Björn 'besser82' Esser 2019-01-14 20:18:57 UTC
(In reply to Michael Schwendt from comment #1)
> claws-mail doesn't use libxcrypt. My patch to make it use libnettle has been
> merged.

For some reason it still requires `libcrypt.so.1`, thus I'm rebuilding it to either have that unneeded requirement dropped by the rebuild or to have it linked against `libcrypt.so.2`.  Are you sure it doesn't use the crypt() function in some other place?

Comment 3 Michael Schwendt 2019-01-14 21:52:17 UTC
It is due to broken libperl ldflags, which respecify many libs libperl is linked with itself:

$ perl -MExtUtils::Embed -e ldopts
-Wl,--enable-new-dtags -Wl,-z,relro -Wl,-z,now -specs=/usr/lib/rpm/redhat/redhat-hardened-ld -Wl,-z,relro -Wl,-z,now -specs=/usr/lib/rpm/redhat/redhat-hardened-ld -fstack-protector-strong -L/usr/local/lib  -L/usr/lib64/perl5/CORE -lperl -lpthread -lresolv -ldl -lm -lcrypt -lutil -lc

Comment 4 Björn 'besser82' Esser 2019-01-15 08:10:41 UTC
Well, those shouldn't be a problem, as we link `--as-needed` in Rawhide.

I figured out the real reason `dnf repoquery --whatrequires 'libcrypt.so.1*'` reports all package version available in the repo without a way to just get the latest EVR.  Thus I still got some false positive results in my query…  :/

Comment 5 Björn 'besser82' Esser 2019-01-16 14:07:45 UTC
Rebuilds have finished.  The announce for testing has been mailed to fedora-devel [1] and the corresponding package-maintainers individually.

Ready for QA!


[1]  https://lists.fedoraproject.org/archives/list/devel@lists.fedoraproject.org/message/K6SXKV72GU7V5WSNUOEMVOSQLTRG6BC6/

Comment 6 Björn 'besser82' Esser 2019-01-17 12:15:12 UTC
(In reply to Michael Schwendt from comment #3)
> It is due to broken libperl ldflags, which respecify many libs libperl is
> linked with itself:
> …

I just checked that and discovered, that the autotools / automake setup of claws-mail is broken in a way, that it clobbers / discards the system's {C,CXX,LD}FLAGS in almost every subdir of the source-tree.

Comment 7 Fedora Update System 2019-01-19 04:22:50 UTC
gsequencer-2.1.38-0.fc28 has been submitted as an update to Fedora 28. https://bodhi.fedoraproject.org/updates/FEDORA-2019-b3288236e3

Comment 8 Fedora Update System 2019-01-19 04:23:08 UTC
gsequencer-2.1.38-0.fc29 has been submitted as an update to Fedora 29. https://bodhi.fedoraproject.org/updates/FEDORA-2019-0076e52045

Comment 9 Björn 'besser82' Esser 2019-01-19 08:51:08 UTC
Resetting status after removing this bug from the mentioned updates in Bodhi.

Comment 10 Ben Cotton 2020-04-30 22:16:00 UTC
This message is a reminder that Fedora 30 is nearing its end of life.
Fedora will stop maintaining and issuing updates for Fedora 30 on 2020-05-26.
It is Fedora's policy to close all bug reports from releases that are no longer
maintained. At that time this bug will be closed as EOL if it remains open with a
Fedora 'version' of '30'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 30 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 11 Ben Cotton 2020-05-26 14:43:37 UTC
Fedora 30 changed to end-of-life (EOL) status on 2020-05-26. Fedora 30 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.